        Program read_cres2D
c
c       READS MEAN OUTPUTS FROM CLIO:
c
        include 'cresuintnan.com'

!    Please adapt parameter nfield2D to the number of output selected below
        parameter(nfield2=47)

        integer, parameter :: mx=120
	integer, parameter :: my=65
	integer, parameter :: mz=20
	integer, parameter :: one=1
	integer, parameter :: nfield2D=22
	real*4 data(imax,jmax)
	real*4 w1(mx,my)
        real*4 wdatx(imax,jmax,nm), wdaty(imax,jmax,nm)
        real*4 valgu(imtt,jmtt,nm), valgv(imtt,jmtt,nm)
        integer nfi(nfield),ityp(nfield)
        integer t,tk,t0,t1
c
        character*30 name
        real ylon1,dylon,xlat1,dxlat

        character*30 varname2D(nfield2D),uname(nfield2D)
        character*20 varnametmp
        character*50 lname(nfield2D)
c       REAL(kind=4), DIMENSION(:,:,:,:), ALLOCATABLE :: wdata, wdatai

        integer nio0p,njo0p,nmp
        
c       REAL(kind=4), PARAMETER :: xi1 = 28.500, dxi = 3.00
c       REAL(kind=4), PARAMETER :: yj1 =-79.500, dyj = 3.00
c       integer(kind=4), PARAMETER :: iberp =56 , ibera = 103

c       common /wfield/wdata
c       common /wfield2/wdatai
c       common /position/xlon1,ylat1,dlat,dlong
c       common /indices/nmp,nmef


        j=1
        varname2D(j)='h'
        uname(j)='m'
        lname(j)='bathymetry_on_tracer_gridpoints'
        ityp(j)=1
        jh=j

        j=j+1
        varname2D(j)='fcor'
        uname(j)='1/s'
        lname(j)='Coriolis_parameter_on_momentum_grid'
        ityp(j)=1
 
 
        j=j+1
        varname2D(j)='ubar'
        uname(j)='m/s'
        lname(j)='zonal_barotropic_momentum'
        ityp(j)=2

      
        j=j+1
        varname2D(j)='vbar'
        uname(j)='m/s'
        lname(j)='meridional_barotropic_momentum'
        ityp(j)=2



        j=j+1
        varname2D(j)='ssh'
        uname(j)='m'
        lname(j)='sea_surface_height'
        ityp(j)=1

       
        j=j+1
        varname2D(j)='sst'
        uname(j)='°C'
        lname(j)='sea_surface_temperature'
        ityp(j)=1


        j=j+1
        varname2D(j)='sss'
        uname(j)='psu'
        lname(j)='sea_surface_salinity'
        ityp(j)=1


        j=j+1
        varname2D(j)='shflx'
        uname(j)='W/m^2'
        lname(j)='surface_heat_flux'
        ityp(j)=1


        j=j+1
        varname2D(j)='sfflx'
        uname(j)='m/yr'
        lname(j)='surface_freshwater_flux'
        ityp(j)=1


        j=j+1
        varname2D(j)='zmix'
        uname(j)='m'
        lname(j)='depth_of_ocean_surface_mixed_layer'
        ityp(j)=1


        j=j+1
        varname2D(j)='zcnv'
        uname(j)='m'
        lname(j)='depth_of_convection'
        ityp(j)=1


        j=j+1
        varname2D(j)='msl'
        uname(j)='1'
        lname(j)='G-M_slope'
        ityp(j)=1

        j=j+1
        varname2D(j)='albq'
        uname(j)='1'
        lname(j)='Ice_concentration'
        ityp(j)=1

        jalbq=j


        j=j+1
        varname2D(j)='hice'
        uname(j)='m'
        lname(j)='ice_thickness'
        ityp(j)=1

        jhice=j 


        j=j+1
        varname2D(j)='hicp'
        uname(j)='m'
        lname(j)='ice_production'
        ityp(j)=1

        jhicp=j 


        j=j+1
        varname2D(j)='hsn'
        uname(j)='m'
        lname(j)='snow_thickness'
        ityp(j)=1

        jhsn=j 


        j=j+1
        varname2D(j)='snow'
        uname(j)='m'
        lname(j)='snow_precipitation'
        ityp(j)=1

        jsnow=j 


        j=j+1
        varname2D(j)='fb'
        uname(j)='W/m^2'
        lname(j)='Oceanic_flux_at_the_ice_base'
        ityp(j)=1

        jfb=j 


        j=j+1
        varname2D(j)='tice'
        uname(j)='°C'
        lname(j)='Ice_temperature'
        ityp(j)=1

        jtice=j 


        j=j+1
        varname2D(j)='uice'
        uname(j)='m/s'
        lname(j)='Ice_velocity_u'
        ityp(j)=2

        juice=j 


        j=j+1
        varname2D(j)='vice'
        uname(j)='m/s'
        lname(j)='Ice_velocity_v'
        ityp(j)=2

        jvice=j 


        j=j+1
        varname2D(j)='wsx'
        uname(j)='N/m^2'
        lname(j)='zonal_wind_stress'
        ityp(j)=1


        dlat=dxi
        dlong=dyj
        xlon1=xi1
        ylat1=yj1


        print*,'Read Ocean Model output -2D (read_cres2D.f)'
        print*,'prefix of the file (xxx.nc)'
        read(5,111) name
        print*,'first sample'
        read*,month
        print*,'sample every n1 sample'
        read*,nsnm
        print*,'average over n2 sample'
        read*,nsna
        print*,'number of sample'
        read*,nmp
        print*,'interpo (1) or not(0)'
        read*,ninp
        ninp=1-ninp
        nmpt=1+(nmp-1)*nsnm
        nmef=nfield2D
        nmef=j

c       ALLOCATE(wdata (0:imax,0:jmax,1:nmef,1:nmp))
c       ALLOCATE(wdatai (0:imtt,0:jmtt,1:nmef,1:nmp))

        wdatai(:,:,:,:)=0.0
        wdata(:,:,:,:)=0.0

C--Reading of the files

       jh=1
        t=month

        do t0=1,nmp
         do t1=1,nsna

            
           do kfield=1,nfield2D
           tk=t
	   if (kfield.eq.jh) then
            tk=1
           endif

           varnametmp=varname2D(kfield)
           call CF_READ2D(TRIM(name)//'.nc',varnametmp,
     &      tk,mx,my,1,w1)
            
	   do i=1,mx  ; do j=1,my
	      wdata(i,j,kfield,t)=wdata(i,j,kfield,t)+
     &        w1(i,j)/nsna
           enddo      ; enddo
	   do j=1,my
            wdata(121,j,kfield,t)=wdata(121,j,kfield,t)+
     &      w1(1,j)/nsna
            wdata(122,j,kfield,t)=wdata(122,j,kfield,t)+
     &       w1(2,j)/nsna
           enddo

           enddo
           t=t+1

         enddo
         t=t+(nsnm-nsna)
        enddo
        do t=1,nmp
         do nmi=1,nfield2D
          do i=1,imax  ; do j=1,jmax
            if (wdata(i,j,jh,1).eq.spv) then 
               wdata(i,j,nmi,t)=spv  
            else
            if(wdata(i,j,jalbq,t).lt.0.05) then
!            wdata(i,j,jalbq,t)=spv
             wdata(i,j,jhice,t)=0.0
             wdata(i,j,jhicp,t)=0.0
             wdata(i,j,jhsn,t)=0.0
             wdata(i,j,jsnow,t)=0.0
             wdata(i,j,jtice,t)=0.0
             wdata(i,j,juice,t)=0.0
             wdata(i,j,jvice,t)=0.0
            endif
            endif
          enddo      ; enddo
         enddo
        enddo 

 
c     cyclic correspondance
      ims1 = 2
      ims2 = imax-1
      jcl1 = 2
      jcl2 = jeq
c
      do i=1,nmef
       do nmi=1,nmp
        do  j=jcl1,jcl2
         wdata(ims1-1,j,i,nmi) = wdata(ims2,j,i,nmi)
         wdata(ims2+1,j,i,nmi) = wdata(ims1,j,i,nmi)
	 do ii=ibera-5,ibera+5
	  wdata(ii,jmax,i,nmi) = spv
!  write(*,*)ii,nmi
         enddo
	 do ii=iberp-5,iberp+5
	  wdata(ii,jsepar,i,nmi) = spv
         enddo
        enddo
       enddo
      enddo
c
c Interpolation or not
c
      if (ninp.eq.1) then
         nio0p=imax-2
         njo0p=jmax
	 dxlat=dlat
	 dylon=dlong
	 xlat1=ylat1
	 ylon1=xlon1
      else
         nio0p=imtt
         njo0p=jmtt
         call gridtt(ttlon,ttlat,imtt,jmtt)
         xlat1=ttlat(1)
         dxlat=ttlat(2)-ttlat(1)
         ylon1=ttlon(1)
         dylon=ttlon(2)-ttlon(1)
         call mercat(nmp,ttlon,ttlat,nmef)
         do n=1,nmef
           if (ityp(n).eq.2) then
            do i=1,imax
             do j=1,jmax
              do nn=1,nmp
               wdatx(i,j,nn)=wdata(i,j,n,nn)
               wdaty(i,j,nn)=wdata(i,j,n+1,nn)
              enddo
             enddo
            enddo
            call mercatv(nmp,ttlon,ttlat,wdatx,wdaty,valgu,valgv)
            do i=1,imtt
             do j=1,jmtt
              do nn=1,nmp
               wdatai(i,j,n,nn)=valgu(i,j,nn)
               wdatai(i,j,n+1,nn)=valgv(i,j,nn)
              enddo
             enddo
            enddo
            ityp(n)=1
            ityp(n+1)=1
           endif
         enddo
               
      endif
C
C Writing of the fields
c
      open (8, FILE=TRIM(name)//'2D.bin', FORM='UNFORMATTED')
      write(8)nio0p,njo0p,one,nmp,ylon1,dylon,xlat1,dxlat,
     &  nfield2D,spv
      write(*,*)nio0p,njo0p,one,nmp,ylon1,dylon,xlat1,dxlat,
     &  nfield2D,spv
      write(8)(varname2D(i),i=1,nfield2D)
      write(8)(lname(i),i=1,nfield2D)
      write(8)(uname(i),i=1,nfield2D)

      do i=1,nfield2D
       do nmi=1,nmp
        if (ninp.eq.1) then
        do J=1,nio0p ; do k=1,njo0p
         write(8) wdata(J,K,i,nmi)
!        write(*,*) wdata(J,K,i,nmi) 
        enddo        ; enddo
        else
        do J=1,nio0p ; do k=1,njo0p
         write(8) wdatai(J,K,i,nmi)
!        write(*,*) wdatai(J,K,i,nmi)
        enddo        ; enddo
        endif
       enddo
      enddo
      close(8)
 
 111  format(45A)
 1000 format(A30,1x,E13.6,1x,I6,1x,I6,1x,I6,1x,I6)
 1001 format(A32,1x,E13.6,1x,I6,1x,I6,1x,I6,1x,I6)
 1111 format(3(F7.2,1X,F7.3,1X),I3,A)

      stop
      write(*,*)'End of read_cres2D'
      write(*,*)'--------------------------------------'

      end

      subroutine mercat(nmp,ttlon,ttlat,nmef)
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c--INTERPOLATION OF SCALAR DATA PLACED AT THE CENTER OF THE
c--ELEMENTS OF A TWO RECTANGULAR GRID ONTO ONE GRID.
c--LONGITUDE-LATITUDE COORDINATES FOR BOTH GRIDS.
c--DATA ARE OUTPUTS OF THE PROGRAM OTI.
c--This subroutine is identical to mercat.f except for input and ouputs
c
c--M.A.Morales Maqueda, 11-IV-1994.
c--modified by H.GOOSSE 15-IV-1994
c--modified by H.GOOSSE + M.A.M. Maqueda 15-IV-1994
c--modified by H.GOOSSE 16-V-1994
c  modif : 14/10/94

c--(alpha,beta): (latitude,longitude) of the north pole of the new grid.
c
      include 'cresuintnan.com'

      parameter ( nsmax = 2 )

      dimension  gwlon(0:imax), gwlat(0:jmax+1)
      dimension  galat(0:imax), galon(0:jmax+1)
      dimension  val(0:imax,0:jmax+1,nm)
C     real*4  vala(imtt,jmtt,nm)
      dimension  whigri(imtt,jmtt)
c     real*4 wdata (0:imax,0:jmax,1:nmef,1:nmp)
c     real*4 wdatai (0:imtt,0:jmtt,1:nmef,1:nmp)

 
c     common /wfield/wdata
c     common /wfield2/wdatai
c     common /position/xlon1,ylat1,dlat,dlong
c     common /indices/nmp,nmef

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

 1001  format(A32,1x,E13.6,1x,I6,1x,I6,1x,I6,1x,I6)
 1000  format(A30,1x,E13.6,1x,I6,1x,I6,1x,I6,1x,I6)
 1111  format(3(F7.2,1X,F7.3,1X),I3,A)
 
c--DEFINITION OF CONSTANTS.
c  pi    : pi 
c  radian: value of one radian in degrees.
c  degre : value of one degre in radian .
 
      pi     = 4.0d0 * atan(1.0d0)
      radian = pi/180.0
      degre  = 180.0/pi
      untour = 360.0d0
      epsil = 0.1d-9
 
c--DEFINITION OF ROTATION ANGLES
 
      alpha =    0.0
      beta  = -111.0
C     spv    = 9999.0
      im=imax
      jm=jmax
 
C         do 215 j=jj1,jj2,jj3
C           read(10,fmt) (val(i,j,k),i=iis,iie)
C215      continue

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  3 ) definition de la nouvelle grille .                              |
c-----------------------------------------------------------------------

c-----
c--DEFINE INTERPOLATING GRID WW.
c
C     call gridtt(ttlon,ttlat,imtt,jmtt)

c--DEFINE ORIGINAL GRIDS.
c----
      xaj1 =  90. + yj1
      yai1 =  90. + beta + untour - xi1
      dxaj = dyj
      dyai = -dxi
      do 330 i=0,imax
        gwlon(i) = xi1 + dxi * DFLOAT(i-1)
        galat(i) = 90. + beta + untour - gwlon(i)
 330  continue
      do 335 j=0,jmax+1
        gwlat(j) = yj1 + dyj * DFLOAT(j-1)
        galon(j) = 90. + gwlat(j)
 335  continue

C        write(6,*) 'galon :'
C        write(6,'(20F6.1)') (galon(j),j=0,jmax+1)
C        write(6,*) 'galat :'
C        write(6,'(20F6.1)') (galat(i),i=0,imax)

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
 
c--COOMPUTE DE CORRESPONDANCE BETWEEN GRIDS
 
      call choiceg(ttlat,ttlon,imtt,jmtt,whigri)
 
      open (15,file='choiceg.dat')
      do 350 j=1,jmtt
C       write(15,'(122(F8.3))') (whigri(i,j),i=1,imtt)
        write(15,'(122(i1))') (int(whigri(i,j)),i=1,imtt)
 350  continue
      close (15)

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  4 ) Traitement de la nouvelle grille colonne par colonne .          |
c-----------------------------------------------------------------------

c--MAIN DO-LOOP.
 
      do 550 j=1,jmtt
       do 550 i=1,imtt
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c--debut du traitement de la colonne (i,j) :
         if (whigri(i,j).eq.1.) then
           dxw = ttlon(i)
           dyw = ttlat(j)
           gxw = xi1 + mod(dxw-xi1+untour, untour)
           xxx = ( gxw - xi1 ) / dxi + 0.5
           iwp = nint(xxx) 
           iwp = max(0,min(imax-1,iwp))
           dr = gwlon(iwp+1) - gxw
           dl = gxw - gwlon(iwp)
           yyy = ( dyw - yj1 ) / dyj + 0.5
           jwp = nint(yyy) 
           jwp = max(1,min(jmax,jwp))
           du = gwlat(jwp+1) - dyw
           dd = dyw - gwlat(jwp)
         else
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
           yw   = ttlat(j)
           dyw  = yw*radian
           dsyw = sin(dyw)
           dcyw = cos(dyw)
           xw   = mod(ttlon(i)-beta, untour)
           dxw  = xw*radian
           dsxw = sin(dxw)
           dcxw = cos(dxw)
c--COMPUTE COORDINATES ON THE SS GRID OF A POINT OF THE AA GRID.
           dya = asin(dcyw*dcxw) * degre
           dxa = atan2(dcyw*dsxw,-dsyw) * degre
           dxa = mod(dxa+untour, untour)
c---
           yyy = ( dxa - xaj1 ) / dxaj + 0.5
           jwp = nint(yyy) 
           jwp = max(0,min(jmax,jwp))
           du = galon(jwp+1) - dxa
           dd = dxa - galon(jwp)
           xxx = ( dya - yai1 ) / dyai + 0.5
           iwp = nint(xxx) 
           iwp = max(0,min(imax-1,iwp))
           dr = galat(iwp+1) - dya
           dl = dya - galat(iwp)

         endif
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c--Pour verification :
C        goto 550
	 nn0=999999.99
	 nn1=999999.99
         if (ttlon(i).ge.369. .or. ttlon(i).le.-1. ) then
           nprt = nprt + 1
           if (nprt.ge.nn0 .and.  nprt.le.nn1 ) then
             write(99,*) 'nprt, whigri(i,j) :', nprt, whigri(i,j)
             write(99,*) 'i,j, iwp, jwp :'
             write(99,*)  i,j, iwp, jwp
             write(99,*) 'dl, dr, dd, du :'
             write(99,*)  dl, dr, dd, du
             if ( whigri(i,j).eq.1.0d0) then
               write(99,*) 'dxw, dyw :'
               write(99,*)  dxw, dyw
             else
               write(99,*) 'dxa, dya :'
               write(99,*)  dxa, dya 
             endif
C            write(99,*) ' ttlon, ttlat :', ttlon(i), ttlat(j)
C            write(99,*) ' gwlon, gwlat :', gwlon(iwp), gwlat(jwp)
C            write(99,*) ' galon, galat :', galon(jwp), galat(iwp)
           endif
         endif

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c   5 ) Interpolation a partir des 4 voisins iwp/iwp+1,jwp/jwp+1 .     |
c-----------------------------------------------------------------------

c--POINT (i,j). A POINT IS CONSIDERED TO BE A LAND POINT 
c--IF THE NEAREST DATA POINT IS A LAND POINT.
 
          unsdtx = 1.0 / (dl + dr)
          rl = dl * unsdtx
          rr = dr * unsdtx
          unsdty = 1.0 / (dd + du)
          rd = dd * unsdty
          ru = du * unsdty

          do 530 k=1,nmef
C         do 530 k=1,1
          do 530 nn=1,nmp
c--debut du traitement du point (i,j,k) :
C         valcl = val(iwp,jwp,k)
C         valcr = val(iwp+1,jwp,k)
          valcl = wdata(iwp,jwp,k,nn)
          valcr = wdata(iwp+1,jwp,k,nn)
	  if (valcl.eq.spv) then
	    if (rl.le.0.5) then
	      valad = valcl
	    else
	      valad = valcr
	      valcd = valcr
	    endif
	  else
	    if (valcr.eq.spv) then
	      if (rr.le.0.5) then
	        valad = valcr
	      else
		valad = valcl
	        valcd = valcl
	      endif
	    else
	      valad = valcl * rr + valcr * rl
              valcd = valad
            endif
	  endif
c
C         valcl = val(iwp,jwp+1,k)
C         valcr = val(iwp+1,jwp+1,k)
          valcl = wdata(iwp,jwp+1,k,nn)
          valcr = wdata(iwp+1,jwp+1,k,nn)
	  if (valcl.eq.spv) then
	    if (rl.le.0.5) then
	      valau = valcl
	    else
	      valau = valcr
	      valcu = valcr
	    endif
	  else
	    if (valcr.eq.spv) then
	      if (rr.le.0.5) then
	        valau = valcr
	      else
		valau = valcl
	        valcu = valcl
	      endif
	    else
	      valau = valcl * rr + valcr * rl
              valcu = valau
            endif
	  endif
c
	  if (valad.eq.spv) then
	    if (rd.le.0.5) then
C	      vala(i,j,k)  = spv
 	      wdatai(i,j,k,nn)  = spv
	    else
	      if (valau.eq.spv) then
C	        vala(i,j,k) = spv
 	        wdatai(i,j,k,nn) = spv
	      else
	        valc        = valcu
C               vala(i,j,k) = valcu
                wdatai(i,j,k,nn) = valcu
	      endif
	    endif
	  else
	    if (valau.eq.spv) then
	      if (ru.le.0.5) then
C	        vala(i,j,k) = spv
	        wdatai(i,j,k,nn) = spv
	      else
		valc        = valcd
C               vala(i,j,k) = valcd
                wdatai(i,j,k,nn) = valcd
	      endif
	    else
	      valc        = valcd * ru + valcu * rd
C             vala(i,j,k) = valc
              wdatai(i,j,k,nn) = valc
            endif
	  endif

c         if (whigri(i,j).eq.2) write(6,*) vala(i,j,k)
c--Pour verification : 
	 nn0=999999.99
	 nn1=999999.99
         if (ttlon(i).ge.369. .or. ttlon(i).le.-1. ) then
           if (nprt.ge.nn0 .and.  nprt.le.nn1 ) then
             write(99,*) 'val(i,i+1,/j,j+1) ='
             write(99,'(4F10.4)') val(iwp,jwp,1), val(iwp+1,jwp,1),
     &                            val(iwp,jwp+1,1), val(iwp+1,jwp+1,1)
C            write(99,*) 'vala(i,j,1) =', vala(i,j,1)
             write(99,*) 'wdatai(i,j,1,1) =', wdatai(i,j,1,1)
           endif
         endif

c--fin du traitement du point (i,j,k) .
 530   continue
c--fin du traitement de la colonne (i,j) .
 550   continue
c
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  6 ) ecriture sur fichier . 
c-----------------------------------------------------------------------


c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      return
      end
      subroutine gridtt(ttlon,ttlat,imtt,jmtt)
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c
c--DEFINE INTERPOLATING GRID TT.
c--LATITUDES AND LONGITUDES CORRESPOND TO THE CENTERS OF THE GRID ELEMENTS.
c
      implicit double precision (a-h,o-z)
c
      dimension ttlon(imtt),ttlat(jmtt)
C     xlong1 = 23
      xlong1 = 0.0
      delx=360.0/real(imtt)
      dely=180.0/real(jmtt)
      do 10 i=1,imtt
C       ttlon(i)=xlong1+real(i-1)*delx+0.5*delx
        ttlon(i)=xlong1+real(i-1)*delx
        ttlon(i)=mod(ttlon(i),360.0d0)
10    continue
      do 20 j=1,jmtt
        ttlat(j)=-90.+real(j-1)*dely+0.5*dely
20    continue
      return
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      end

      subroutine choiceg(ttlat,ttlong,imtt,jmtt,whigri)
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c
c               THIS ROUTINE DETERMINE AT WHICH ORIGINAL GRID (AA OR WW)
c               EACH POINT OF TT CORRESPOND.
c
      implicit double precision (a-h,o-z)
c
      dimension whigri(imtt,jmtt)
      dimension ttlat(jmtt),ttlong(imtt)
c     
C     write(6,*) 'begining of choiceg'
      do 10 i=1,imtt
         do 10 j=1,jmtt
            whigri(i,j)=1.
10    continue
c
C     write(6,*) 'after 10'
      do 20 i=1,imtt
         do 20 j=1,jmtt
           if (ttlat(j).gt.0.0.and.ttlat(j).le.8.0) then
            if ((ttlong(i).ge.290.).or.(ttlong(i).lt.30.)) then
              whigri(i,j)=2.
c             write(10,*) ttlat(j),ttlong(i)
            endif
           endif
           if ((ttlat(j).gt.8.).and.(ttlat(j).le.10.)) then
            xoncri=281.+(ttlat(j)-8.)/(10.-8.)*(276.-281.)
            if (ttlong(i).ge.xoncri.or.ttlong(i).lt.30.) whigri(i,j)=2.
           endif
           if ((ttlat(j).gt.10.).and.(ttlat(j).le.15.)) then
            xoncri=276.+(ttlat(j)-10.)/(15.-10.)*(270.-276.)
            if (ttlong(i).ge.xoncri.or.ttlong(i).lt.30.) whigri(i,j)=2.
           endif
           if ((ttlat(j).gt.15.).and.(ttlat(j).le.20.)) then
            xoncri=270.+(ttlat(j)-15.)/(20.-15.)*(260.-270.)
            if (ttlong(i).ge.xoncri.or.ttlong(i).lt.30) whigri(i,j)=2.
           endif
           if ((ttlat(j).gt.20.).and.(ttlat(j).le.30.)) then
            xoncri=260.+(ttlat(j)-20.)/(30.-20.)*(260.-260.)
            if (ttlong(i).ge.xoncri.or.ttlong(i).lt.30.) whigri(i,j)=2.
           endif
           if ((ttlat(j).gt.30.).and.(ttlat(j).le.68.)) then
            xoncri=260.+(ttlat(j)-30.)/(65.-30.)*(260.-260.)
            if (ttlong(i).ge.xoncri.or.ttlong(i).lt.50.) whigri(i,j)=2.
           endif
           if ((ttlat(j).gt.67.).and.(ttlat(j).le.90.)) then
             xoncri=0
             if (ttlong(i).ge.xoncri.or.ttlong(i).lt.360.) whigri(i,j)=2.
           endif
c
20    continue
c
C     write(6,*) 'end of choiceg'
      return
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      end
C
      subroutine mercatv(nmp,ttlon,ttlat,wdatx,wdaty,valgu,valgv)
C
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c--INTERPOLATION OF SCALAR DATA PLACED AT THE CENTER OF THE
c--ELEMENTS OF A TWO RECTANGULAR GRID ONTO ONE GRID.
c--LONGITUDE-LATITUDE COORDINATES FOR BOTH GRIDS.
c--DATA ARE OUTPUTS OF THE PROGRAM OTI.
c
c--M.A.Morales Maqueda, 11-IV-1994.
c--modified by H.GOOSSE 15-IV-1994
c--modified by H.GOOSSE + M.A.M. Maqueda 15-IV-1994
c--modified by H.GOOSSE 16-V-1994
c--modified by JMC 19/09/95, adapted for vector, (derived from "provect").
c  modif : 21/09/95
 
c--(alpha,beta): (latitude,longitude) of the north pole of the new grid.
c
      include 'cresuintnan.com'
 
      parameter ( nsmax = 2 )
 
      dimension gwlon(0:imax), gwlat(0:jmax+1)
      dimension galat(0:imax), galon(0:jmax+1)
      dimension cxw(0:imax), sxw(0:imax), cyw(0:jmax+1), syw(0:jmax+1)
      dimension cya(0:imax), sya(0:imax), cxa(0:jmax+1), sxa(0:jmax+1)
C     dimension valu(0:imax,0:jmax+1,nm), valv(0:imax,0:jmax+1,nm)
      real*4 wdatx(imax,jmax,nm), wdaty(imax,jmax,nm)
      dimension valx(0:imax,0:jmax+1,nm), valy(0:imax,0:jmax+1,nm)
      dimension valz(0:imax,0:jmax+1,nm)
 
      real*4 valgu(imtt,jmtt,nm), valgv(imtt,jmtt,nm)
      dimension cxt(imtt), sxt(imtt), cyt(jmtt), syt(jmtt)
      dimension whigri(imtt,jmtt)
c     real*4 wdata (0:imax,0:jmax,1:nmef,1:nmp)
c     real*4 wdatai (0:imtt,0:jmtt,1:nmef,1:nmp)

 
c     common /wfield/wdata
c     common /wfield2/wdatai
c     common /position/xlon1,ylat1,dlat,dlong
c     common /indices/nmp,nmef


c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
 
 1001 format(A32,1x,E13.6,1x,I6,1x,I6,1x,I6,1x,I6)
 1000 format(A30,1x,E13.6,1x,I6,1x,I6,1x,I6,1x,I6)
 1111 format(3(F7.2,1X,F7.3,1X),I3,A)
 
c--DEFINITION OF CONSTANTS.
c  pi    : pi
c  radian: value of one radian in degrees.
c  degre : value of one degre in radian .
c  separ : facteur de separation entre spv / normal value.
 
      pi     = 4.0d0 * atan(1.0d0)
      radian = pi/180.0
      degre  = 180.0/pi
      untour = 360.0d0
      epsil = 0.1d-9
      zero = 0.0
      one  = 1.0
      separ = 0.5 + epsil
 
c--DEFINITION OF ROTATION ANGLES
 
      alpha =    0.0  ! Ne peut plus etre modifie.
      beta  = -111.0
C     spv    = 9999.0
      spvw = spv
 
c--READ DATA.
      im=imax
      jm=jmax
      ktr=nmp
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
 
c--Initialisation :
      do 200 n=1,nm
       do 200 j=0,jmax+1
        do 200 i=0,imax
C        valu(i,j,n) = spv
C        valv(i,j,n) = spv
         valx(i,j,n) = 0.
         valy(i,j,n) = 0.
         valz(i,j,n) = 0.
 200  continue
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  3 ) definition de la nouvelle grille .                              |
c-----------------------------------------------------------------------
 
c-----
c--DEFINE INTERPOLATING GRID WW.
c
      call gridtt(ttlon,ttlat,imtt,jmtt)
      do 320 i=1,imtt
        cxt(i) = cos(radian*(ttlon(i)-beta))
        sxt(i) = sin(radian*(ttlon(i)-beta))
 320  continue
      do 325 j=1,jmtt
        cyt(j) = cos(radian*ttlat(j))
        syt(j) = sin(radian*ttlat(j))
 325  continue
 
c--DEFINE ORIGINAL GRIDS.
c----
c     xi1=xlon1
c     dxi=dlong
c     yj1=ylat1
c     dyj=dlat

      xaj1 =  90. + yj1
      yai1 =  90. + beta + untour - xi1
      dxaj = dyj
      dyai = -dxi
      do 330 i=0,imax
        gwlon(i) = xi1 + dxi * DFLOAT(i-1)
        galat(i) = 90. + beta + untour - gwlon(i)
        cxw(i) = cos(radian*(gwlon(i)-beta))
        sxw(i) = sin(radian*(gwlon(i)-beta))
        cya(i) = cos(radian*galat(i))
        sya(i) = sin(radian*galat(i))
 330  continue
      do 335 j=0,jmax+1
        gwlat(j) = yj1 + dyj * DFLOAT(j-1)
        galon(j) = 90. + gwlat(j)
        cyw(j) = cos(radian*gwlat(j))
        syw(j) = sin(radian*gwlat(j))
        cxa(j) = cos(radian*galon(j))
        sxa(j) = sin(radian*galon(j))
 335  continue
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
 
c--COOMPUTE DE CORRESPONDANCE BETWEEN GRIDS
 
      call choiceg(ttlat,ttlon,imtt,jmtt,whigri)
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c--calcul des 3 composantes dans le repere fixe .
 
      ylim1 = 69.0
      ylim2 = 294.0
c- critere d'apartenace a Grille AA : y > min[ 69., max(0., 294. - x) ]
      do 380 j=1,jm
       do 380 i=1,im
        ylim = min(ylim1, max(zero, ylim2-gwlon(i)) )
        if (gwlat(j).le.ylim) then
c- WW :
        do 370 k=1,ktr
         valx(i,j,k) = -sxw(i)*wdatx(i,j,k)-syw(j)*cxw(i)*wdaty(i,j,k)
         valy(i,j,k) =  cxw(i)*wdatx(i,j,k)-syw(j)*sxw(i)*wdaty(i,j,k)
         valz(i,j,k) =  cyw(j)*wdaty(i,j,k)
 370    continue
 
        else
c- AA :
        do 375 k=1,ktr
         valz(i,j,k) =  sxa(j)*wdaty(i,j,k)-sya(i)*cxa(j)*wdatx(i,j,k)
         valy(i,j,k) =  cxa(j)*wdaty(i,j,k)+sya(i)*sxa(j)*wdatx(i,j,k)
         valx(i,j,k) = -cya(i)*wdatx(i,j,k)
 375    continue
        endif
 380  continue
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c  4 ) Traitement de la nouvelle grille colonne par colonne .          |
c-----------------------------------------------------------------------
 
c--MAIN DO-LOOP.
 
      do 550 j=1,jmtt
       do 550 i=1,imtt
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c--debut du traitement de la colonne (i,j) :
         if (whigri(i,j).eq.1.) then
           dxw = ttlon(i)
           dyw = ttlat(j)
           gxw = xi1 + mod(dxw-xi1+untour, untour)
           xxx = ( gxw - xi1 ) / dxi + 0.5
           iwp = nint(xxx)
           iwp = max(0,min(imax-1,iwp))
           dr = gwlon(iwp+1) - gxw
           dl = gxw - gwlon(iwp)
           yyy = ( dyw - yj1 ) / dyj + 0.5
           jwp = nint(yyy)
           jwp = max(0,min(jmax,jwp))
           du = gwlat(jwp+1) - dyw
           dd = dyw - gwlat(jwp)
         else
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c--COMPUTE COORDINATES ON THE SS GRID OF A POINT OF THE AA GRID.
           dya = asin(cyt(j)*cxt(i)) * degre
           dxa = atan2(cyt(j)*sxt(i),-syt(j)) * degre
           dxa = mod(dxa+untour, untour)
c---
           yyy = ( dxa - xaj1 ) / dxaj + 0.5
           jwp = nint(yyy)
           jwp = max(0,min(jmax,jwp))
           du = galon(jwp+1) - dxa
           dd = dxa - galon(jwp)
           xxx = ( dya - yai1 ) / dyai + 0.5
           iwp = nint(xxx)
           iwp = max(0,min(imax-1,iwp))
           dr = galat(iwp+1) - dya
           dl = dya - galat(iwp)
 
         endif
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
 
c--Pour verification :
C        goto 550
         nn0=999999.99
         nn1=999999.99
         if (ttlon(i).ge.369. .or. ttlon(i).le.-1. ) then
           nprt = nprt + 1
           if (nprt.ge.nn0 .and.  nprt.le.nn1 ) then
             write(99,*) 'nprt, whigri(i,j) :', nprt, whigri(i,j)
             write(99,*) 'i,j, iwp, jwp :'
             write(99,*)  i,j, iwp, jwp
             write(99,*) 'dl, dr, dd, du :'
             write(99,*)  dl, dr, dd, du
             if ( whigri(i,j).eq.1.0d0) then
               write(99,*) 'dxw, dyw :'
               write(99,*)  dxw, dyw
             else
               write(99,*) 'dxa, dya :'
               write(99,*)  dxa, dya
             endif
C            write(99,*) ' ttlon, ttlat :', ttlon(i), ttlat(j)
C            write(99,*) ' gwlon, gwlat :', gwlon(iwp), gwlat(jwp)
C            write(99,*) ' galon, galat :', galon(jwp), galat(iwp)
           endif
         endif
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c   5 ) Interpolation a partir des 4 voisins iwp/iwp+1,jwp/jwp+1 .     |
c-----------------------------------------------------------------------
 
c--POINT (i,j). A POINT IS CONSIDERED TO BE A LAND POINT
c--IF THE NEAREST DATA POINT IS A LAND POINT.
 
          unsdtx = 1.0 / (dl + dr)
          rl = dl * unsdtx
          rr = dr * unsdtx
          unsdty = 1.0 / (dd + du)
          rd = dd * unsdty
          ru = du * unsdty
 
          do 530 k=1,ktr
c--debut du traitement du point (i,j,k) :
 
	  if (wdatx(iwp,jwp,k).eq.spv) then
	    if (rl.le.separ) then
	      valdw = spv
	    else
	      valdw = wdatx(iwp+1,jwp,k)
	      valxd = valx(iwp+1,jwp,k)
	      valyd = valy(iwp+1,jwp,k)
	      valzd = valz(iwp+1,jwp,k)
	    endif
	  else
	    if (wdatx(iwp+1,jwp,k).eq.spv) then
	      if (rr.le.separ) then
	        valdw = spv
	      else
		valdw = wdatx(iwp,jwp,k)
	        valxd = valx(iwp,jwp,k)
	        valyd = valy(iwp,jwp,k)
	        valzd = valz(iwp,jwp,k)
	      endif
	    else
		valdw = rr*wdatx(iwp,jwp,k)+rl*wdatx(iwp+1,jwp,k)
	        valxd = rr*valx(iwp,jwp,k) + rl*valx(iwp+1,jwp,k)
	        valyd = rr*valy(iwp,jwp,k) + rl*valy(iwp+1,jwp,k)
	        valzd = rr*valz(iwp,jwp,k) + rl*valz(iwp+1,jwp,k)
            endif
	  endif
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c
	  if (wdatx(iwp,jwp+1,k).eq.spv) then
	    if (rl.le.separ) then
	      valup = spv
	    else
	      valup = wdatx(iwp+1,jwp+1,k)
	      valxu = valx(iwp+1,jwp+1,k)
	      valyu = valy(iwp+1,jwp+1,k)
	      valzu = valz(iwp+1,jwp+1,k)
	    endif
	  else
	    if (wdatx(iwp+1,jwp+1,k).eq.spv) then
	      if (rr.le.separ) then
	        valup = spv
	      else
	        valup = wdatx(iwp,jwp+1,k)
	        valxu = valx(iwp,jwp+1,k)
	        valyu = valy(iwp,jwp+1,k)
	        valzu = valz(iwp,jwp+1,k)
	      endif
	    else
		valup = rr*wdatx(iwp,jwp+1,k)+rl*wdatx(iwp+1,jwp+1,k)
	        valxu = rr*valx(iwp,jwp+1,k) + rl*valx(iwp+1,jwp+1,k)
	        valyu = rr*valy(iwp,jwp+1,k) + rl*valy(iwp+1,jwp+1,k)
	        valzu = rr*valz(iwp,jwp+1,k) + rl*valz(iwp+1,jwp+1,k)
            endif
	  endif
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c
	  if (valdw.eq.spv) then
	    if (rd.le.separ) then
	      valg  = spvw
	      valgu(i,j,k)  = spvw
	      valgv(i,j,k)  = spvw
	    else
	      if (valup.eq.spv) then
	        valg  = spvw
	        valgu(i,j,k)  = spvw
	        valgv(i,j,k)  = spvw
	      else
		valg = valup
                valgu(i,j,k) = -sxt(i)*valxu + cxt(i)*valyu
                valgv(i,j,k) =  cyt(j)*valzu - syt(j) *
     &                        ( cxt(i)*valxu + sxt(i)*valyu )
C               valgv(i,j,k) =  valzu / cyt(j)
	      endif
	    endif
	  else
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
	    if (valup.eq.spv) then
	      if (ru.le.separ) then
	        valg  = spvw
	        valgu(i,j,k)  = spvw
	        valgv(i,j,k)  = spvw
	      else
		valg = valdw
                valgu(i,j,k) = -sxt(i)*valxd + cxt(i)*valyd
                valgv(i,j,k) =  cyt(j)*valzd - syt(j) *
     &                        ( cxt(i)*valxd + sxt(i)*valyd )
C               valgv(i,j,k) =  valzd / cyt(j)
	      endif
	    else
		valg  = rd*valup + ru*valdw
	        vvx = rd*valxu + ru*valxd
	        vvy = rd*valyu + ru*valyd
	        vvz = rd*valzu + ru*valzd
                valgu(i,j,k) = -sxt(i)*vvx + cxt(i)*vvy
                valgv(i,j,k) =  cyt(j)*vvz - syt(j) *
     &                        ( cxt(i)*vvx + sxt(i)*vvy )
C               valgv(i,j,k) =  vvz / cyt(j)
            endif
	  endif
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
          nncrv=1
          if (nncrv.eq.0) valgu(i,j,k) = valg
 
c         if (whigri(i,j).eq.2) write(6,*) valgu(i,j,k)
c--Pour verification :
         if (ttlon(i).ge.369. .or. ttlon(i).le.-1. ) then
           if (nprt.ge.nn0 .and.  nprt.le.nn1 ) then
C            write(99,*) 'valu(i,i+1,/j,j+1) ='
C            write(99,'(4F10.4)') valu(iwp,jwp,1), valu(iwp+1,jwp,1),
C    &                          valu(iwp,jwp+1,1), valu(iwp+1,jwp+1,1)
             write(99,*) 'valgu(i,j,1) =', valgu(i,j,1)
           endif
         endif
 
c--fin du traitement du point (i,j,k) .
 530   continue
c--fin du traitement de la colonne (i,j) .
 550   continue
c
      return
 
c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      end
