      program evo2gra
c---5----|----5----|----5----|----5----|----5----|----5----|----5----|72--5----|
c   Read data (usual format )(jm > 0 => j increasing) file = fildat .
c   work on several variables (im) , 1 per column
 

      parameter (nbcmax = 200)
      parameter (nchmax = 90)
c     parameter (nszmax = 10000*120)
      integer nszmax
      integer, parameter ::mx=2
      integer, parameter ::one=1
      real,parameter     ::oner=1.
c--dummy variables :
c     real var(nszmax)
      real, dimension(:), allocatable :: var
      real*4, dimension(:,:), allocatable :: sort
c     real*4 sort(120,10000)
      character*80 tit1
      character*30 titvar(nbcmax)
      character*30 tit,tit2,titvar1,titvar2
      character*128 fildat, ainput,infile
      character*30, dimension(:), allocatable :: namvar,uname
      character*50, dimension(:), allocatable :: lname
      integer iinput,ks,numdat,itest
 
c--variables locales
      character*2  cc2
      character*10 cc10
      character*30 fmt , fmtitr , fmtw
      character*40 ccline
      character*70 line
 
 1000 format(A30,1x,E13.6,1x,I6,1x,I6,1x,I6,1x,I6)
 1111 format(3(F7.1,1X,F7.3,1X),I3,A)
 
     
c---5----|----5----|----5----|----5----|----5----|----5----|----5----|72--5----|
c  1 ) Ouverture et lecture de l'entete du fichier :                   |
c-----------------------------------------------------------------------
 
      call inputt(5,numdat)

      fildat = ainput()
!write(6,'(A)') 'Number of the arrays to vizualise ? '
!  // '(-num < 0 for prolongation ; num > 0 if last)'
      ks = iinput()
 
      numf=5
      open(unit=10, file = TRIM(fildat), status='old')
 
      write(*,*)'Read EVOLU (read_evolu.f)'
      write(*,*)'Input file = ',TRIM(fildat)
      write(*,*)'Output file = ',TRIM(fildat)//'.bin'
      ltest = 2
      kprec = 0
      km = 0
      jprec = 0
      read(10,'(2A)') fmt, line
      read(line,*)  ovsc, im, jm, km, nfrc
      read(10,*) xi1, dxi, yj1, dyj, zk1, dzk, ntyp
      jmp = abs(jm)
      nszmax=im*jm
 
      allocate (namvar(1:im))
      allocate (lname(1:im))
      allocate (uname(1:im))
      allocate (sort(1:im,1:jm))
      allocate (var(1:nszmax))

c entree au clavier du numero du tableau (ou bloc) a traiter
      if (km.eq.1) then
        ks = 0
      endif
        
      if(ks.eq.0) then
        write(*,*) 'num = 0 ! par defaut lecture du tableau qui suit'
        ks = 1
        ltest = 1
      elseif (ks.gt.0) then
        ks = max0(1,ks - kprec)
        ltest = 0
      else
        ks = -ks
        ks = max0(1,ks - kprec)
        ltest = 2
      endif

 
c---5----|----5----|----5----|----5----|----5----|----5----|----5----|72--5----|
c  2 ) lecture standard de plusieurs tableaux [ou blocs si km=0]       |
c-----------------------------------------------------------------------
 
c--positionnement au debut du tableau (km # 0) a traiter :
      if  (km.ne.0.and.ks.ge.2) then
        if (nfrc.ge.1) then
          njj = (im-1)/nfrc + 1
          njj = (ks - 1) * (njj*jmp + 3)
        else
          njj = (im-1)/(-nfrc) + 1
          njj = (ks - 1) * (njj*(jmp+1) + 3)
        endif
        do 210 j=1,njj
           read(10,*)
 210    continue
      endif
 
c--positionnement au debut du bloc (km = 0) a traiter :
      if (km.eq.0.and.ks.ge.2) then
        ktot = 1
        do 230 k=1,ks-1
c- lecture d'un bloc :
          if (nfrc.ge.1) then
            njj = (im-1)/nfrc + 1
            njj = ktot * (njj*jmp + 3)
          else
            njj = (im-1)/(-nfrc) + 1
            njj = ktot * (njj*(jmp+1) + 3)
          endif
          do 220 j=1,njj
            read(10,*)
 220      continue
          read(10,'(2A)') fmt, line
          read(line,*)  ovsc, im, jm, ktot, nfrc
          read(10,*) xi1, dxi, yj1, dyj, zk1, dzk, ntyp
          ktot = max0(1,iabs(ktot))
          jmp = abs(jm)
 230    continue
      endif
 
      if(jprec.eq.0) spval = ovsc
 
c--verification des dimensions :
      nsz = (jmp+jprec) * im
      if(nsz.gt.nszmax) then
        write(6,*) 'Arret dans rdcour :'
     a     //' Pb de sous-dimensionnement des tableaux !'
        stop
      endif
 
c--lecture du 1er titre du tableau :
      cc10 = tit1(47:56)
      read(10,'(A)') tit1
      if (km.ne.0) then
        write(6,*) 'Titre associe au tableau traite (1 ligne) :'
        write(6,'(A79)') tit1
      else
c       write(6,*) 'Titre du 1er bloc (1 ligne) :'
c       write(6,'(A79)') tit1
        if(len(tit1).ge.56.and.kprec.ne.0) tit1(47:56) = cc10
      endif
 
c--lecture du 2nd titre du tableau :
      do 250 i=1,nbcmax
        titvar(i) = ' '
 250  continue
      if(dxi.eq.0.) then
        nccv = nint(xi1)
        nbc = im
      else
        nccv = nint(yj1)
        nbc = jmp
      endif
      nbc = min0(nbc,nbcmax)
      if(nccv.ge.1.and.nccv.le.nchmax) then
c- Morcellement du 2nd titre :
cccccccccccccc
        write(cc2,'(I2)') nccv
        if(nccv.le.9) cc2 = cc2(2:)//' '
        write(fmtitr,'(A,I3,A)') '(',nbcmax,'A'//cc2//')'
        read(10,fmtitr) (titvar(i),i=1,nbc)
      else
        nccv = 0
        read(10,'(A)') titvar(1)
      endif
 
c---5----|----5----|----5----|----5----|----5----|----5----|----5----|72--5----|
c  3 ) lecture standard du tableau selectione :                        |
c-----------------------------------------------------------------------
 
c--lecture directe (j crois.) ou indirecte (j decrois.) selon le signe de jm :
      jj1 = max(1,-jm)
      jj2 = max(jm,1)
      jj3 = sign(1,jm)
      if (nfrc.ge.0) then
        do 310 j=jj1,jj2,jj3
          nj = (jprec + j -1) * im
          read(10,fmt) (var(i+nj),i=1,im)
 310    continue
        read(10,*)
      else
        do 320 iis = 1,im,-nfrc
          iie = min(im,iis-nfrc-1)
          do 315 j=jj1,jj2,jj3
            nj = (jprec + j -1) * im
            read(10,fmt) (var(i+nj),i=iis,iie)
 315      continue
          read(10,*)
 320    continue
      endif
 
c---5----|----5----|----5----|----5----|----5----|----5----|----5----|72--5----|
 
c--Uniformisation de la valeur speciale :
      if(ovsc.ne.spval) then
        do 410 j=1,jmp
         nj = (jprec + j - 1) * im
         do 410 i=1,im
           if(var(i+nj).eq.ovsc) var(i+nj) = spval
 410    continue
      endif
 
c--Prolongation du set de donnees par celles d'un autre tableau :
      jprec = jprec + jmp
      kprec = kprec + ks
c     if(ltest.eq.1) then
c       write(6,*) 'Prolonge avec la lecture d un autre tableau ? '
c    &           //'(0 non, > 0 oui) :'
c       call rdstdin(numf,ccline)
c       read(ccline,*) ltest
c     endif
c     if(ltest.ge.1) goto 110
 
      jm = jprec
      close(10)
 
c--mise en place de "nturn" :
      nturn = 0
      if (km.le.0) nturn = nint(dzk)

      titvar(2)='Tyr'
      do i=1,im
        if (TRIM(titvar(i)).eq.'NoIt') then
         lname(i)='Number_of_the_iteration'
         uname(i)='1'
        endif
        if (TRIM(titvar(i)).eq.'Tyr') then
         lname(i)='Time_of_the_output'
         uname(i)='year'
        endif
        if ((TRIM(titvar(i)).eq.'EgAjC').or.
     &      (TRIM(titvar(i)).eq.'egajc')) then
         lname(i)='Energy_dissipated_by_convective_adjustment'
         uname(i)='J'
        endif
        if ((TRIM(titvar(i)).eq.'V_AjC').or.
     &      (TRIM(titvar(i)).eq.'v_ajc')) then
c        titvar(i)='VAjC'
         lname(i)='Volume_of_ocean_involved_in_convective_adjustment'
         uname(i)='%'
        endif
        if ((TRIM(titvar(i)).eq.'D.Eta').or.
     &      (TRIM(titvar(i)).eq.'d.eta')) then
c         titvar(i)='deta'
         lname(i)='Time_derivative_of_sea_surface_elevation'
         uname(i)='?m/s?'
        endif
        if ((TRIM(titvar(i)).eq.'M.Eta').or.
     &      (TRIM(titvar(i)).eq.'m.eta')) then
c titvar(i)='meta'
         lname(i)='Mean_sea_surface_elevation'
         uname(i)='m'
        endif
        if ((TRIM(titvar(i)).eq.'DrHSF').or.
     &       (TRIM(titvar(i)).eq.'drhsf')) then
         lname(i)='Transport_through_Drake_passage'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'InHSF').or.
     &     (TRIM(titvar(i)).eq.'inhsf')) then
         lname(i)='Transport_through_Indonesian_passage'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'BeHSF').or.
     &      (TRIM(titvar(i)).eq.'behsf')) then
         lname(i)='Transport_through_Bering_Strait'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'DANS').or.
     &      (TRIM(titvar(i)).eq.'dans')) then
         lname(i)='Southward_transport_through_Danemark_Strait'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'FLOS').or.
     &      (TRIM(titvar(i)).eq.'flos'))  then
         lname(i)='Transport_through_Florida_Strait'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'DANN').or.
     &      (TRIM(titvar(i)).eq.'dann')) then
         lname(i)='Northward_transport_through_Danemark_Strait'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'ISCS').or.
     &      (TRIM(titvar(i)).eq.'iscs')) then
         lname(i)='Southward_trans_bet_Iceland_Norway'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'ISCN').or.
     &      (TRIM(titvar(i)).eq.'iscn')) then
         lname(i)='Northward_trans_bet_Iceland_Norway'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'FRAS').or.
     &      (TRIM(titvar(i)).eq.'fras')) then
         lname(i)='Southward_trans_through_Fram_Strait'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'FRAN').or.
     &      (TRIM(titvar(i)).eq.'fran')) then
         lname(i)='Northward_trans_through_Fram_Strait'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'PNWS').or.
     &       (TRIM(titvar(i)).eq.'pnws')) then
         lname(i)='Southward_trans_through_Canadian_A.'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'PNWN').or.
     &       (TRIM(titvar(i)).eq.'pnwn')) then
         lname(i)='Northward_trans_through_Canadian_A.'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'ADGIN').or.
     &      (TRIM(titvar(i)).eq.'adgin')) then
         lname(i)='Maximum_of_merid_streamfunction_GIN_seas'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'ADPro').or.
     &      (TRIM(titvar(i)).eq.'adpro')) then
         lname(i)='Maximum_of_merid_streamf_in_the_North '
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'ADOut').or.
     &      (TRIM(titvar(i)).eq.'adout')) then
         lname(i)='Maximum_of_merid_streamfunction_at_20S'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'AABpr').or.
     &     (TRIM(titvar(i)).eq.'aabpr')) then
         lname(i)='Maximum_of_merid_streamf_in_the_South'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'AABex').or.
     &      (TRIM(titvar(i)).eq.'aabex'))  then
         lname(i)='Maximum_of_merid_streamf_in_bottom_cell'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'AABat').or.
     &      (TRIM(titvar(i)).eq.'aabat')) then
         lname(i)='AABW_exported_north_in_Atlantic_at_20S'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'Fc30A').or.
     &      (TRIM(titvar(i)).eq.'fc30a')) then
         lname(i)='Meridional_heat_transport_in_the_Atlantic_ocean_30S'
         uname(i)='PW'
        endif
        if ((TRIM(titvar(i)).eq.'Fs30A').or.
     &      (TRIM(titvar(i)).eq.'fs30a')) then
         lname(i)='Meridional_salt_transport_in_the_Atlantic_ocean_30S'
         uname(i)='kg/'
        endif
        if ((TRIM(titvar(i)).eq.'Fsber').or.
     &      (TRIM(titvar(i)).eq.'fsber')) then
         lname(i)='salt_transport_at_Bering_Strait'
         uname(i)='kg/'
        endif
        if ((TRIM(titvar(i)).eq.'T-c').or.
     &      (TRIM(titvar(i)).eq.'t-c')) then
c titvar(i)='tmc'
         lname(i)='Global_ocean_temperature'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T1-o').or.
     &    (TRIM(titvar(i)).eq.'t1-o')) then
	 titvar(i)='T1mo'
         lname(i)='Diff_of_sst_between_model_and_obs'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'|T-o|').or.
     &      (TRIM(titvar(i)).eq.'|Tmo|')) then
c titvar(i)='atmo'
         lname(i)='Mean_error_on_temperature'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'S-30').or.
     &     (TRIM(titvar(i)).eq.'s-30')) then
c titvar(i)='Sm30'
         lname(i)='Mean_ocean_salinity-30psu'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S1-o').or.
     &     (TRIM(titvar(i)).eq.'s1-o')) then
         lname(i)='Diff_of_sss_between_model_and_observation'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'|S-o|').or.
     &      (TRIM(titvar(i)).eq.'|s-o|')) then
c titvar(i)='asmo'
         lname(i)='Mean_error_on_Salinity'
         uname(i)='psu'
        endif
        if (TRIM(titvar(i)).eq.'|w|') then
c titvar(i)='aw'
         lname(i)='Mean_oceanic_vertical_velocity'
         uname(i)='m/s'
        endif
        if (TRIM(titvar(i)).eq.'|u|') then
c titvar(i)='au'
         lname(i)='Mean_oceanic_horizontal_velocity(u)'
         uname(i)='m/s'
        endif
        if (TRIM(titvar(i)).eq.'|v|') then
c titvar(i)='av'
         lname(i)='Mean_oceanic_horizontal_velocity(v)'
         uname(i)='m/s'
        endif
        if ((TRIM(titvar(i)).eq.'K.E').or.
     &      (TRIM(titvar(i)).eq.'k.e')) then
c titvar(i)='KE'
         lname(i)='Kinetic_energy'
         uname(i)='m^2/s^2'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 1').or.
     &      (TRIM(titvar(i)).eq.'t-o 1')) then
c titvar(i)='Tmo1'
         lname(i)='Mean_error_on_temperature_at_level1'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 2').or.
     &      (TRIM(titvar(i)).eq.'t-o 2')) then
c titvar(i)='Tmo2'
         lname(i)='Mean_error_on_temperature_at_level2'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 3').or.
     &      (TRIM(titvar(i)).eq.'t-o 3')) then
c titvar(i)='Tmo3'
         lname(i)='Mean_error_on_temperature_at_level3'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 4').or.
     &      (TRIM(titvar(i)).eq.'t-o 4')) then
c titvar(i)='Tmo4'
         lname(i)='Mean_error_on_temperature_at_level4'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 5').or.
     &      (TRIM(titvar(i)).eq.'t-o 5')) then
c titvar(i)='Tmo5'
         lname(i)='Mean_error_on_temperature_at_level5'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 6').or.
     &      (TRIM(titvar(i)).eq.'t-o 6')) then
c titvar(i)='Tmo6'
         lname(i)='Mean_error_on_temperature_at_level6'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 7').or.
     &      (TRIM(titvar(i)).eq.'t-o 7')) then
c titvar(i)='Tmo7'
         lname(i)='Mean_error_on_temperature_at_level7'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 8').or.
     &      (TRIM(titvar(i)).eq.'t-o 8')) then
c titvar(i)='Tmo8'
         lname(i)='Mean_error_on_temperature_at_level8'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 9').or.
     &      (TRIM(titvar(i)).eq.'t-o 9')) then
c titvar(i)='Tmo9'
         lname(i)='Mean_error_on_temperature_at_level9'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 10').or.
     &      (TRIM(titvar(i)).eq.'t-o 10')) then
c titvar(i)='Tmo10'
         lname(i)='Mean_error_on_temperature_at_level10'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 11').or.
     &      (TRIM(titvar(i)).eq.'t-o 11')) then
c titvar(i)='Tmo11'
         lname(i)='Mean_error_on_temperature_at_level11'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 12').or.
     &      (TRIM(titvar(i)).eq.'t-o 12')) then
c titvar(i)='Tmo12'
         lname(i)='Mean_error_on_temperature_at_level12'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 13').or.
     &      (TRIM(titvar(i)).eq.'t-o 13')) then
c titvar(i)='Tmo13'
         lname(i)='Mean_error_on_temperature_at_level13'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 14').or.
     &      (TRIM(titvar(i)).eq.'t-o 14')) then
c titvar(i)='Tmo14'
         lname(i)='Mean_error_on_temperature_at_level14'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 15').or.
     &      (TRIM(titvar(i)).eq.'t-o 15')) then
c titvar(i)='Tmo15'
         lname(i)='Mean_error_on_temperature_at_level15'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 18').or.
     &      (TRIM(titvar(i)).eq.'t-o 18')) then
c titvar(i)='Tmo16'
         lname(i)='Mean_error_on_temperature_at_level16'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 17').or.
     &      (TRIM(titvar(i)).eq.'t-o 17')) then
c titvar(i)='Tmo17'
         lname(i)='Mean_error_on_temperature_at_level17'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 18').or.
     &      (TRIM(titvar(i)).eq.'t-o 18')) then
c titvar(i)='Tmo18'
         lname(i)='Mean_error_on_temperature_at_level18'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 19').or.
     &      (TRIM(titvar(i)).eq.'t-o 19')) then
c titvar(i)='Tmo19'
         lname(i)='Mean_error_on_temperature_at_level19'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'T-o 20').or.
     &      (TRIM(titvar(i)).eq.'t-o 20')) then
c titvar(i)='Tmo20'
         lname(i)='Mean_error_on_temperature_at_level20'
         uname(i)='°C'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 1').or.
     &      (TRIM(titvar(i)).eq.'s-o 1')) then
c titvar(i)='Smo1'
         lname(i)='Mean_error_on_salinity_at_level1'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 2').or.
     &      (TRIM(titvar(i)).eq.'s-o 2')) then
c titvar(i)='Smo2'
         lname(i)='Mean_error_on_salinity_at_level2'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 3').or.
     &      (TRIM(titvar(i)).eq.'s-o 3')) then
c titvar(i)='Smo3'
         lname(i)='Mean_error_on_salinity_at_level3'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 4').or.
     &      (TRIM(titvar(i)).eq.'s-o 4')) then
c titvar(i)='Smo4'
         lname(i)='Mean_error_on_salinity_at_level4'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 5').or.
     &      (TRIM(titvar(i)).eq.'s-o 5')) then
c titvar(i)='Smo5'
         lname(i)='Mean_error_on_salinity_at_level5'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 6').or.
     &      (TRIM(titvar(i)).eq.'s-o 6')) then
c titvar(i)='Smo6'
         lname(i)='Mean_error_on_salinity_at_level6'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 7').or.
     &      (TRIM(titvar(i)).eq.'s-o 7')) then
c titvar(i)='Smo7'
         lname(i)='Mean_error_on_salinity_at_level7'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 8').or.
     &      (TRIM(titvar(i)).eq.'s-o 8')) then
c titvar(i)='Smo8'
         lname(i)='Mean_error_on_salinity_at_level8'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 9').or.
     &      (TRIM(titvar(i)).eq.'s-o 9')) then
c titvar(i)='Smo9'
         lname(i)='Mean_error_on_salinity_at_level9'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 10').or.
     &      (TRIM(titvar(i)).eq.'s-o 10')) then
c titvar(i)='Smo10'
         lname(i)='Mean_error_on_salinity_at_level10'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 11').or.
     &      (TRIM(titvar(i)).eq.'s-o 11')) then
c titvar(i)='Smo11'
         lname(i)='Mean_error_on_salinity_at_level11'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 12').or.
     &      (TRIM(titvar(i)).eq.'s-o 12')) then
c titvar(i)='Smo12'
         lname(i)='Mean_error_on_salinity_at_level12'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 13').or.
     &      (TRIM(titvar(i)).eq.'s-o 13')) then
c titvar(i)='Smo13'
         lname(i)='Mean_error_on_salinity_at_level13'
         uname(i)='psu'
        endif
c titvar(i)='Smo14'
        if ((TRIM(titvar(i)).eq.'S-o 14').or.
     &      (TRIM(titvar(i)).eq.'s-o 14')) then
         lname(i)='Mean_error_on_salinity_at_level14'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 15').or.
     &      (TRIM(titvar(i)).eq.'s-o 15')) then
c titvar(i)='Smo15'
         lname(i)='Mean_error_on_salinity_at_level15'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 16').or.
     &      (TRIM(titvar(i)).eq.'s-o 16')) then
c titvar(i)='Smo16'
         lname(i)='Mean_error_on_salinity_at_level16'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 17').or.
     &      (TRIM(titvar(i)).eq.'s-o 17')) then
c titvar(i)='Smo17'
         lname(i)='Mean_error_on_salinity_at_level17'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 18').or.
     &      (TRIM(titvar(i)).eq.'s-o 18')) then
c titvar(i)='Smo18'
         lname(i)='Mean_error_on_salinity_at_level18'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 19').or.
     &      (TRIM(titvar(i)).eq.'s-o 19')) then
c titvar(i)='Smo19'
         lname(i)='Mean_error_on_salinity_at_level19'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'S-o 20').or.
     &      (TRIM(titvar(i)).eq.'s-o 20')) then
c titvar(i)='Smo20'
         lname(i)='Mean_error_on_salinity_at_level20'
         uname(i)='psu'
        endif
        if ((TRIM(titvar(i)).eq.'AIEFN').or.
     &    (TRIM(titvar(i)).eq.'aiefn')) then
         lname(i)='Sea_ice_area_in_NH'
         uname(i)='10^6km^2'
        endif
        if ((TRIM(titvar(i)).eq.'AIEFS').or.
     &     (TRIM(titvar(i)).eq.'aiefs')) then
         lname(i)='Sea_ice_area_in_SH'
         uname(i)='10^6km^2'
        endif
        if ((TRIM(titvar(i)).eq.'A15N').or. 
     &      (TRIM(titvar(i)).eq.'a15n')) then
         lname(i)='Sea_ice_extent(85%)_in_NH'
         uname(i)='10^6km^2'
        endif
        if ((TRIM(titvar(i)).eq.'A15S').or.
     &    (TRIM(titvar(i)).eq.'a15s')) then
         lname(i)='Sea_ice_extent(85%)_in_SH'
         uname(i)='10^6km^2'
        endif
        if ((TRIM(titvar(i)).eq.'A85N').or.
     &     (TRIM(titvar(i)).eq.'a85n')) then
         lname(i)='Sea_ice_extent(15%)_in_NH'
         uname(i)='10^6km^2'
        endif
        if ((TRIM(titvar(i)).eq.'A85S').or.
     &      (TRIM(titvar(i)).eq.'a85s')) then
         lname(i)='Sea_ice_extent(15%)_in_SH'
         uname(i)='10^6km^2'
        endif
        if ((TRIM(titvar(i)).eq.'ALEN').or.
     &     (TRIM(titvar(i)).eq.'alen')) then
         lname(i)='Leads_area_in_NH'
         uname(i)='10^6km^2'
        endif
        if ((TRIM(titvar(i)).eq.'ALES').or.
     &       (TRIM(titvar(i)).eq.'ales')) then
         lname(i)='Leads_area_in_SH'
         uname(i)='10^6km^2'
        endif
        if ((TRIM(titvar(i)).eq.'VOLN').or.
     &     (TRIM(titvar(i)).eq.'voln')) then
         lname(i)='Sea_ice_volume_in_NH'
         uname(i)='10^3km^3'
        endif
        if ((TRIM(titvar(i)).eq.'VOLS').or.
     &      (TRIM(titvar(i)).eq.'vols')) then
         lname(i)='Sea_ice_volume_in_SH'
         uname(i)='10^3km^3'
        endif
          if ((TRIM(titvar(i)).eq.'VONN').or.
     &     (TRIM(titvar(i)).eq.'vonn')) then
         lname(i)='Snow_volume_over_seaice_NH'
         uname(i)='10^3km^3'
        endif
        if ((TRIM(titvar(i)).eq.'VONS').or.
     &        (TRIM(titvar(i)).eq.'vons')) then
         lname(i)='Snow_volume_over_seaice_SH'
         uname(i)='10^3km^3'
        endif
        if ((TRIM(titvar(i)).eq.'ECGN').or.
     &      (TRIM(titvar(i)).eq.'ecgn')) then
         lname(i)='Mean_sea_ice_velocity_NH'
         uname(i)='m/s'
        endif
        if ((TRIM(titvar(i)).eq.'ECGS').or.
     &     (TRIM(titvar(i)).eq.'ecgs')) then
         lname(i)='Mean_sea_ice_velocity_SH'
         uname(i)='m/s'
        endif
        if ((TRIM(titvar(i)).eq.'FRAG').or.
     &      (TRIM(titvar(i)).eq.'frag')) then
         lname(i)='Sea_ice_trans_through_Fram_Strait'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'SPNG').or.
     &   (TRIM(titvar(i)).eq.'spng')) then
         lname(i)='Sea_ice_transp_Spitz_and_Norway'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'BERG').or.
     &    (TRIM(titvar(i)).eq.'berg')) then
         lname(i)='Sea_ice_trans_through_Bering_Strait'
         uname(i)='Sv'
        endif
        if ((TRIM(titvar(i)).eq.'ThEx').or.
     &       (TRIM(titvar(i)).eq.'thex')) then
         lname(i)='Ocean_thermal_expansion'
         uname(i)='m'
        endif
        if ((TRIM(titvar(i)).eq.'ISMM').or.
     &     (TRIM(titvar(i)).eq.'ismm')) then
         lname(i)='Ice_sheet_basal_melt'
         uname(i)='W'
        endif
        if ((TRIM(titvar(i)).eq.'IcbN').or.
     &   (TRIM(titvar(i)).eq.'icbn')) then
         lname(i)='Iceberg_melt_NH'
         uname(i)='m^3/day'
        endif
        if ((TRIM(titvar(i)).eq.'IcbS').or.
     &   (TRIM(titvar(i)).eq.'icbs'))then
         lname(i)='Iceberg_melt_SH'
         uname(i)='m^3/day'
        endif

        if (i.lt.im) then
         tit=titvar(i)
         tit2=titvar(i+1)
        
         nc=LEN_TRIM(titvar(i))
         itest=0
         do n=1,nc
          if ((ichar(tit(n:n)).gt.96).and.
     &      (ichar(tit(n:n)).lt.123)) then
            itest=itest+1
          endif 
	  if ((ichar(tit(n:n)).le.57).and.
     &     (ichar(tit(n:n)).ge.48)) then
           itest=itest+1
          endif
          if ((ichar(tit2(n:n)).gt.64).and.
     &      (ichar(tit2(n:n)).lt.91)) then
            itest=itest+1
          endif
          if ((ichar(tit2(n:n)).le.57).and.
     &     (ichar(tit2(n:n)).ge.48)) then
           itest=itest+1
	  endif
          if ((ichar(tit(n:n)).eq.46).or.
     &     (ichar(tit(n:n)).eq.95).or.
     &     (ichar(tit(n:n)).eq.32)) then
            do m=n,nc-1
             titvar(i)(m:m)=tit(m+1:m+1)
            enddo
            titvar(i)(nc:nc)=' '
            itest=itest+2
          endif 
          if (ichar(tit(n:n)).eq.45) then
             itest=itest+2
             titvar(i)(n:n)='m' 
          endif

          if (ichar(tit(n:n)).eq.124) then
             if (n.ne.nc) then 
              titvar(i)(n:n)='a'
              itest=itest+2
             else
              titvar(i)(n:n)=' '
              itest=itest+2
             endif
          endif
         if (ichar(tit(n:n)).eq.32) itest=itest-1
         enddo
         if ((itest.eq.(2*nc)).and.
     & (ichar(tit(1:1)).eq.(ichar(tit2(1:1))+32))) then
          tit=lname(i)
	  titvar1=titvar(i)
	  titvar2=titvar(i+1)
          titvar(i)=TRIM(titvar1)//'min'
c         lname(i)='Min_'//tit
          titvar(i+1)=TRIM(titvar2)//'max'
c         lname(i+1)='Max_'//tit
          lname(i+1)=lname(i)
c  write(*,*)titvar(i),i
         endif
       endif
c     write(*,*)i,titvar(i),lname(i)
c     if (i.eq.51) write(*,*)titvar(i),titvar(i)(2:2)
      enddo

       do 610 i=1,im
          do 610 j=1,jm
             sort(i,j) = var(i+(j-1)*im)
 610   continue

      open (8, FILE=TRIM(fildat)//'.bin', FORM='UNFORMATTED')
      write(8) mx,one,one,jm,oner,oner,oner,oner,im,spv
      write(8) (titvar(i),i=1,im)
      write(8) (lname(i),i=1,im)
      write(8) (uname(i),i=1,im)
c     do i=1,im
c      write(*,*)i,titvar(i),lname(i),uname(i)
c     enddo
      

      do i=1,im
       do j=1,jm
        write(8) sort(i,j)
        write(8) spv
       enddo
      enddo
      close(8)

      write(*,*)'fin de read_evolu'
      write(*,*)'--------------------------------------'

      end

      


