      program cat_file

*-----------------------------------------
!gather variables from 2 files in one file 
*-----------------------------------------

      implicit none

      integer mx,my,mz,mt,i,j,k,t,numdat,iinput
      integer mx2,my2,mz2,mt2,op,nv
      integer nvar,nvar2,n,num,mtout
      real lon1,dx,lat1,dy,spv
      real lon12,dx2,lat12,dy2,spv2
      real, dimension(:,:,:), allocatable :: tt,tt2
      real ttm
      character*128 ainput,outfile
      character*128, dimension(:), allocatable :: infile 
      integer,parameter :: un=1
      character*30, dimension(:), allocatable :: namvar,unvar
      character*30, dimension(:), allocatable :: namvar2,unvar2
      character*50, dimension(:), allocatable :: lnamvar,lnamvar2 

      call inputt(5,numdat) 
       
      num= iinput()
      allocate (infile(1:num))
      do n=1,num
       infile(n)= ainput()
      enddo

      outfile= ainput()
      write(*,*)'cat ',num,' files (cat_file.f)'
      do n=1,num
       write(*,*)'input file ',n,' =',TRIM(infile(n))
      enddo

      write(*,*)'output file = ',TRIM(outfile)


      
      nvar2=1

      
      open(10,file=infile(1),status='old',form='unformatted')
      read(10) mx,my,mz,mt,lon1,dx,lat1,dy,nvar,spv
      write(*,*)mx,my,mz,mt,lon1,dx,lat1,dy,nvar,spv
      allocate(namvar (1:nvar))
      allocate(lnamvar (1:nvar))
      allocate(unvar (1:nvar))
      read(10) (namvar(i),i=1,nvar)
      read(10) (lnamvar(i),i=1,nvar)
      read(10) (unvar(i),i=1,nvar)


      allocate(namvar2 (1:nvar))
      allocate(lnamvar2 (1:nvar))
      allocate(unvar2 (1:nvar))
      mtout=mt

      do n=2,num
      open(10+n,file=infile(n),status='old',form='unformatted')
      read(10+n) mx2,my2,mz2,mt2,lon12,dx2,lat12,dy2,nvar2,spv2
      if (mx.ne.mx2) then 
        write(*,*) 'dimensions incompatibles:mx',mx,mx2,n  
        goto 999 
      elseif (my.ne.my2) then
        write(*,*) 'dimensions incompatibles:my',my,my2,n 
        goto 999
      elseif (mz.ne.mz2) then
        write(*,*) 'dimensions incompatibles:mz',mz,mz2,n
        goto 999
      elseif (lon1.ne.lon12) then
        write(*,*) 'grilles incompatibles:lon1',lon1,lon12,n
        goto 999
      elseif (lat1.ne.lat12) then
        write(*,*) 'grilles incompatibles:lat1',lat1,lat12,n
        goto 999
      elseif (dy.ne.dy2) then
        write(*,*) 'grilles incompatibles:dy',dy,dy2,n
        goto 999
      elseif (dx.ne.dx2) then
        write(*,*) 'grilles incompatibles:dx',dx,dx2,n
        goto 999
      elseif (nvar.ne.nvar2) then
        write(*,*) 'number of variable incompatible:nvar',nvar,nvar2,n
        goto 999
      endif
      mtout=mtout+mt2
      enddo 

      open(9,file=outfile,status='new',form='unformatted')
      write(9) mx,my,mz,mtout,lon1,dx,lat1,dy,nvar,spv 

      do n=2,num
      read(10+n) (namvar2(i),i=1,nvar2)
      read(10+n) (lnamvar2(i),i=1,nvar2)
      read(10+n) (unvar2(i),i=1,nvar2)

      do i=1,nvar
        if (namvar(i).ne.namvar2(i)) then
           write(*,*) 'incompatible names:namvar',namvar(i),namvar2(i),n
           goto 999
         elseif (lnamvar(i).ne.lnamvar(i)) then
           write(*,*) 'incompatible long names:lnamvar',lnamvar(i),
     &     lnamvar2(i),n 
           goto 999
         elseif (unvar(i).ne.unvar2(i)) then
           write(*,*) 'incompatible units:unvar',unvar(i),unvar2(i),n
           goto 999
         endif
      enddo

      enddo


      write(9) (namvar(i),i=1,nvar),(namvar2(i),i=1,nvar2)
      write(9) (lnamvar(i),i=1,nvar),(lnamvar2(i),i=1,nvar2)
      write(9) (unvar(i),i=1,nvar),(unvar2(i),i=1,nvar2)


      allocate(tt (1:mx,1:my,1:mz))
      allocate(tt2 (1:mx,1:my,1:mz))

      do nv=1,nvar
       do t=1,mt

        do i=1,mx ; do j=1,my ; do k=1,mz
         read(10) tt(i,j,k)
        enddo     ; enddo     ; enddo
        do i=1,mx ; do j=1,my ; do k=1,mz
         write(9) tt(i,j,k)
        enddo     ; enddo     ; enddo  
       enddo

        do n=2,num
         do t=1,mt
          do i=1,mx ; do j=1,my ; do k=1,mz
            read(10+n) tt(i,j,k)
          enddo     ; enddo     ; enddo
          do i=1,mx ; do j=1,my ; do k=1,mz
            write(9) tt(i,j,k)
          enddo     ; enddo     ; enddo
        enddo

       enddo
      enddo

      close(9)
      close(10)
      do n=2,num
       close(10+n)
      enddo

      goto 998
999   stop      
998   write(*,*)'fin de cat_file'
      write(*,*)'--------------------------------------'


      end program

