c23456789012345678901234567890123456789012345678901234567890123456789012
      program fractoread
c-----------------------------------------------------------------------
c *** initialises and sets parameters of the land model
c-----------------------------------------------------------------------
      implicit none

      integer     i,j,ija,ijatm,is,nlat,nlon
      parameter   (nlat=32,nlon=64,ijatm=nlon*nlat)
      real*8      fractocn(ijatm),ds,db,dumwei
      real*8      fracto(nlat,nlon),fractl(nlat,nlon),epss
      
      epss=0.00001


c *** land fraction

      open(1,file='fractoc.dat',form='formatted')

      read(1,*)
      read(1,*) (fractocn(ija),ija=1,ijatm)
      do ija=1,ijatm
        j=int((ija-1)/nlon)+1
        i=ija-(j-1)*nlon
        fracto(j,i)=fractocn(ija)
        if (fracto(j,i).gt.0.990) fracto(j,i)=1.0d0
        fractl(j,i)=1.-fracto(j,i)
      enddo
      open(2,file='fractoc.grads',form='unformatted')
      write(2) ((real(fracto(i,j)),j=1,nlon),i=1,nlat)
      close(2)
      end
