       
C**  +   fnamNC           [char]: Name of the file to be created.        +
C**  +   tit_NC           [char]: Title attribute                        +
C**  +                                                                   +
C**  +  Dimensions:                                                      +
C**  +   NdimNC                 : Total Number of SPATIAL dimensions     +
C**  +                            Notice : Set "time" to dimension No 0  +
C**  +   DFdim(0:NdimNC)        : # discrete values for each dimension   +
C**  +                            Notice : DFdim(0).eq.0                 +
C**  +                            -> UNLIMITED TIME (coord. not defined) +
C**  +                               WARNING: In this case, the NetCDF   +
C**  +                               use a temporary space to duplicate  +
C**  +                               the file -> NOT RECOMMENDED         +
C**  +   MXdim                  : Maximum value of DFdim, = arrays size  +
C**  +   NAMdim(0:NdimNC) [char]: Name of dimensions, except time        +
C**  +   UNIdim(0:NdimNC) [char]: Units of dimensions (attribute)        +
C**  +   VALdim(MXdim,0:NdimNC)[R4]: Values of coordinate for each dimension+
C**  +                                                                   +
C**  +  Variables:                                                       +
C**  +   MX_var                 : Variable's definitions array sizes,    +
C**  +   NtotNC           : Number of defined variables(NtotNC.le.MX_var)+
C**  +   nameNC(MX_var)   [char]: name of variable.                      +
C**  +   unit_vs (MX_var) [char]: physical units of variable (attribute) +
C**  +   SdimNC (4,MX_var)[char]: name of Selected dims (in above list)  +
C**  +                            Blanked or '-' elements = not used     +
C**  +   lnamNC (MX_var)  [char]: Long_name attribute (descript. of var.)+
C**  +                                                                   +
C**  +  List of real attributes to all variables:                        +
C**  +   NattNC                 : Number of Real Attributes (.ge.1 !)    +
C**  +   NAMrat(NattNC)   [char]: NAMes of Real ATtributes  (''=none)    +
C**  +                            (initial value= 0; set it with UNwratt)+
C**  +   NvatNC(NattNC)         : Number of values of these attributes.  +
C**  +   ID__nc                 : Index of the NetCDF file (remains open)+


      character*50 fnamNC,tit_NC

c     integer,parameter :: NdimNC=3
c     integer nDFdim(0:NdimNC)
      integer,dimension(:), allocatable :: nDFdim
      integer MXdim
c     character*30 NAMdim(0:NdimNC)
c     character*30 UNIdim(0:NdimNC)
      character*30,dimension(:), allocatable ::  NAMdim,UNIdim
      real*4,dimension(:,:), allocatable :: VALdim
      integer :: NtotNC
c MXvar definit dans le code      
      character*30,dimension(:), allocatable :: nameNC
      character*30,dimension(:,:), allocatable :: SdimNC
      character*30,dimension(:), allocatable :: unitNC 
      character*50,dimension(:), allocatable :: lnamNC 
      integer, parameter :: NattNC=1
      character*30 NAMrat(NattNC)
      integer NvatNC(NattNC)
      integer ID__nc




